/*********************************************************************
CSE/ENGR 142 Homework 4B
Title:               Rain Gods and Goddesses
Date:                11/16/98

Author:              Ben Larson
Student ID:          9732615
E-mail:              bhl@u.washington.edu
*********************************************************************/
/*----------------------------------------------------------------------------------*/

#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <stdlib.h>		/* contains rand() on MW Codewarrior for Mac */

#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/
	
#ifndef TRUE
  #define TRUE    		1
#endif

#ifndef FALSE
  #define FALSE   		0
#endif

/* Configure the appearance of the buttons on the menu bar */
/*number of pixels of button height and width*/
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	9

/*color of letter on buttons*/
#define SELECTED_COLOR   RED	 
#define UNSELECTED_COLOW BLACK

#define MAX_PRECIP_EVENTS	100
	/*This is the total number of drops possible at one time.*/

#define MAX_TREES 40

#define TREE_WIDTH 6
#define TREE_HEIGHT 35

#define NUM_CLOUDS 9

/* y-coordinate of the top of the "dirt" in the landscape*/
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0

/* Types of precipitations we support */
#define NONE 0
#define RAIN 1
#define SNOW 2
#define HAIL 3

#define RAIN_LIFE 800
#define SNOW_LIFE 400
#define HAIL_LIFE 1600

/*if you add new types of percip, you may need to change this*/
#define MAX_PRECIP_TYPES 3

/*Possible places for mouse clicks*/
#define BUTTON 1
	/*The above means you clicked on SOME button (doesn't say which one yet)*/
#define DIRT 2
	/*The above means you clicked in the dirt area */
#define THERMO 3 
	/* The above means you clicked on the thermometer */
	
/* Define a structure to hold all the info for each drop of precipitation */
typedef struct 				
{
	int x;
	int y;
	int type;
	int color;
	int frame_count; 	/* holds life expectancy of drop */
}	drop_t;

/* Structure for trees */
typedef struct
{
	int x_left;
	int y_bottom;
	int age;
}	tree;

/* Structure for clouds */
typedef struct
{
	int x;
	int y;
	int direction;
	int number;
}	cloud;

/*******************  FUNCTION PROTOTYPES **************************/

	/*redraw all the buttons.
	The parameters tell which button should be highlighted
	*/
void DrawButtons(int current_precip, int current_color, int draw_tree_flg, 
				 int lightning_flg);

/*Clear all percipitation, so the landscape is just as originally*/
void  ClearAllPrecipitation(drop_t drops_ary[], int *num_drops);

/*render (draw) all the precipitation*/
void DrawAllPrecipitation(drop_t current_drop);

void DrawLandscape(int sun_x, int sun_y);

/* Add tree to array and sort it so they draw correctly */
void AddTree(int mouse_x, int mouse_y, tree trees_ary[], 
				int *trees_ary_counter, int *num_trees);

/* draw all the trees to the screen */
void DrawTree(tree trees_ary[], int *num_trees);

/* Draw the thermometer */
void DrawThermometer(int thermo_y);

/* Draws the different types of drops. 
	These functions are called by DrawAllPrecipitation */
void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawHail (int x, int y, int color);

/*Return an integer which tells what KIND of click there was */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was clicked, call an appropriate function to handle it*/
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *clear_weather, int *draw_tree_flg, int *lightning_flg, int *begin_flg);
		
/* prints bad news when conditions not met */
void BadNewsMessage (void);

/* Add Drop to the array */
void AddDrop (int mouse_x, int mouse_y, int current_precip, int current_color, 
				drop_t drops_ary[], int *drops_ary_counter, int *num_drops);

/* Check to see how old drops are. Removes dead drops from the array */
void CheckAge(drop_t drops_ary[], int *num_drops, int *drops_ary_counter);

/* As the temperature changes, the percipitation changes too, so convert 
	them to their proper types */
void Change_Temp (int mouse_y, drop_t drops_ary[], int *num_drops);

/* Draw clouds to the screen second to last. So the precipation appears like it is
	falling from the clouds */
void DrawClouds(cloud clouds_ary[]);

void AddLightning(cloud clouds_ary[], int *l_x1, int *l_y1, int *l_x2, int *l_y2,
					int *l_x3, int *l_y3, int *l_xf, int *l_yf);

void DrawLightning(int x1, int y1, int x2, int y2, int x3, int y3, int xf, int yf);

void PrintText (int *draw_tree_flg, int *begin_flg);

/*****************************************************************************

     MAIN

*****************************************************************************/

	/* main() has two chief purposes: to contain the important variables and 
	initialize them, and to contain the "event loop," which constantly looks 
	to see if an event has happened, and then processes the event by calling 
	an appropriate function.*/

int main(void)
{
  int quit = FALSE;
  int mouse_x, mouse_y;
  char key_hit;

  int begin_flg = TRUE;
  int sun_x =GP142_XMAX - 50, sun_y = GP142_YMAX - 35;
  int cloud_x = -GP142_XMAX + 20, cloud_y = GP142_YMAX - 30;

  /*  The next items tell what weather is happening, 
   its "leading edge" or bottom (how far down it is), and its color.
   As time passes, the bottom gets lower and lower. */

  int precip_type = NONE; 
  int current_precip = NONE, current_color = NONE; /*what to draw next */
  
  drop_t drops_ary[MAX_PRECIP_EVENTS];
  int num_drops = 0; 	/* amount of precip drops */
  int drops_ary_counter = 0; /* counter for number of drops in drops array */	
  int zeroflg;
  
  tree trees_ary[MAX_TREES];  /* location and age of all trees */
  int num_trees = 0;		/* number of trees in array */
  int trees_ary_counter = 0;  /* placeholder for array */
  
  int draw_tree_flg = FALSE;  /* wether to draw trees or not */
  
  cloud clouds_ary[NUM_CLOUDS];
  
  int i;  /* counter */
  int thermo_y = 10,  change_temp_delay = 0;

  time_t t;
  int random;  /* holds random numbers */
 
  /*This flag will be true if all weather should be cleared*/
  int clear_flag = FALSE;

  /* Flag will be TRUE if we allow lightning */
  int lightning_flg = FALSE;
  int l_x1, l_y1, l_x2, l_y2, l_x3, l_y3, l_xf, l_yf;
  int lightning_life = 5;
  int collision = 0;
  
  /*what kind of click was there?*/
  int mouse_click;

  int event; /*the most recent GP142 event*/

  /* INITIALIZATIONS   */
  
  srand (time(&t));	      /* Seed the random number generator             */
		/*This is something you should do if you plan to use random numbers.
		Put it here in your program and forget about it.*/
		
  GP142_open();           /* Open and init the GP142 Graphics Window      */
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */

  GP142_clear();	      /* This will clear the window & paint it white. */
  GP142_animate(ANI_RUN); /* Start animation so precips will grow         */

  DrawLandscape(sun_x, sun_y);
  DrawButtons(current_precip, current_color, draw_tree_flg, lightning_flg);	  
	/* Show the buttons...*/ 
  ClearAllPrecipitation(drops_ary, &num_drops);

  /* initialize clouds_ary, starting locations and directions don't matter much
  	since they are all randomized later, but they have to start somewhere */
  	clouds_ary[0].x = -GP142_XMAX + 30;
  	clouds_ary[0].y = GP142_YMAX - 30;
  	clouds_ary[0].direction = 1;
  	clouds_ary[0].number = 0;
  	
  	clouds_ary[1].x = -GP142_XMAX + 80;
  	clouds_ary[1].y = GP142_YMAX - 60;
  	clouds_ary[1].direction = -1;
  	clouds_ary[1].number = 1;
  	
  	clouds_ary[2].x = -GP142_XMAX + 100;
  	clouds_ary[2].y = GP142_YMAX - 20;
  	clouds_ary[2].direction = 1;
  	clouds_ary[2].number = 2;
  
  	clouds_ary[3].x = -GP142_XMAX + 250;
  	clouds_ary[3].y = GP142_YMAX - 40;
  	clouds_ary[3].direction = -1;
   	clouds_ary[3].number = 3;
  	
  	clouds_ary[4].x = -GP142_XMAX + 205;
  	clouds_ary[4].y = GP142_YMAX -50;
  	clouds_ary[4].direction = 1;
  	clouds_ary[4].number = 4;
  	  	
  	clouds_ary[5].x = -GP142_XMAX + 150;
  	clouds_ary[5].y = GP142_YMAX -65;
  	clouds_ary[5].direction = -1;
  	clouds_ary[5].number = 5;

	clouds_ary[6].x = -GP142_XMAX + 50;
  	clouds_ary[6].y = GP142_YMAX -75;
  	clouds_ary[6].direction = 1;
  	clouds_ary[6].number = 5;

	clouds_ary[7].x = -GP142_XMAX + 350;
  	clouds_ary[7].y = GP142_YMAX -35;
  	clouds_ary[7].direction = -1;
  	clouds_ary[7].number = 5;

	clouds_ary[8].x = -GP142_XMAX + 300;
  	clouds_ary[8].y = GP142_YMAX -45;
  	clouds_ary[8].direction = 1;
  	clouds_ary[8].number = 5;
  	
  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */
  while (!quit) {  /*this is the famous "event loop" */

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    case GP142_QUIT:
      quit = TRUE;           /* set flag to terminate loop           */
      break;

    case GP142_KBD:
		/*not needed for this program.*/
		/*Use this if user will need to hit a key.
		/*Note that scanf CANNOT be used with GP142*/
      break;

    case GP142_MOUSE:
    
    /* make the program run "blitz schnell" on a windows machine */
    	#if defined(WINDOWS)

		  SetTimer ((HWND)GetActiveWindow (),(UINT)NULL,(UINT)1,NULL);

        #endif
		/* a mouse click has occurred. */
      /* check for button versus dirt */
      /* handle appropriate button click, if any */
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	if (mouse_click == BUTTON) 
	{
			/* a button has been clicked.  Call a function to handle it*/
		handle_button(mouse_x, mouse_y, &current_precip, &current_color, 
					&clear_flag, &draw_tree_flg, &lightning_flg, &begin_flg);
 
		if (clear_flag)
			ClearAllPrecipitation(drops_ary, &num_drops);
		else if (lightning_flg)
			AddLightning(clouds_ary, &l_x1, &l_y1, &l_x2, &l_y2, &l_x3, &l_y3, &l_xf, &l_yf); 
	}
	 	/* change temp */
	else if (mouse_click == THERMO) 
		thermo_y = mouse_y;

	else if ((mouse_click != DIRT)
		/*it's not a button, and it's not the dirt, and lightning is off,
		 it must be sky, and we allow precipiation*/
		&& 
		 (current_precip != NONE) && (current_color != NONE)
		 && (!lightning_flg))
	{
		AddDrop (mouse_x, mouse_y, current_precip, current_color, drops_ary, 
				&drops_ary_counter, &num_drops);
	}			
		/* if flag is on, then draw trees in the dirt */
	else if (mouse_click == DIRT && draw_tree_flg)
		AddTree(mouse_x, mouse_y, trees_ary, &trees_ary_counter, &num_trees);
	
      break;
	
    case GP142_PERIODIC:
      	
		if (lightning_flg)
 			lightning_life--;
 		
 		if (lightning_life == 0)
 		{	
 			lightning_flg = FALSE;
 			lightning_life = 8;	
      	}
      	
      	zeroflg = 0;
      
      	for (i = 0; i < num_drops; i++)
      	{      	
      		/* subtract one from each drops frame count and
      		check to see if drop has out-lived it's life expectancy */
      		
      		drops_ary[i].frame_count -= 1;
      		
      		if (drops_ary[i].frame_count == 0)
      		  zeroflg = 1;
      		
      		/* reset height if drop gets to bottom */
    		if(drops_ary[i].y < TOP_OF_DIRT -20)
				drops_ary[i].y = GP142_YMAX;
				
		/*Some time has passed, so make all the precipitation a little lower*/
			switch (drops_ary[i].type)
			{
				case RAIN:
					drops_ary[i].y -= 2;
				  break;
				case SNOW:
					drops_ary[i].y -= 1;
				  break;
				case HAIL:
					drops_ary[i].y -= 3;
				  break;
				default:
				  break;
			}
      	
			/* move precip left and right */
			random = rand();
			
			if ( random % 10 == 1 && drops_ary[i].type  == HAIL)
				(drops_ary[i].x)++;
				
			else if ( random % 10 == 2 && drops_ary[i].type  == HAIL)
				(drops_ary[i].x)--;
			
			if ( random % 6 == 1 && drops_ary[i].type  == RAIN)
				(drops_ary[i].x)++;
				
			else if ( random % 6 == 2 && drops_ary[i].type  == RAIN)
				(drops_ary[i].x)--;
			
			if ( random % 3 == 0 && drops_ary[i].type  == SNOW)
				(drops_ary[i].x)++;
				
			else if ( random % 3 == 1 && drops_ary[i].type  == SNOW)
				(drops_ary[i].x)--;      	
      	}
      	
      	/* if flag true then call function. We use the flag because calling the
      	function more times than necessary creates a performance hit */
      	if (zeroflg == 1)
      	CheckAge(drops_ary, &num_drops, &drops_ary_counter);
		
		/* temperatures change gradually, hence the delay */
		change_temp_delay++;
		if (change_temp_delay == 15)
		{	Change_Temp (thermo_y, drops_ary, &num_drops);
			change_temp_delay = 0;
		}
				
		/*Grow Trees */
		for (i = 0; i < num_trees; i++)
		{
			if (trees_ary[i].age < 50)
				trees_ary[i].age += 1;
		}

		/*and change the sun's position a little bit*/
		sun_x --;
		if (sun_x < -GP142_XMAX -30) {
			sun_x = - sun_x;
			sun_y = sun_y -1;
				/* over a long period of time, the sun will set.*/
		}
		
		/* move clouds across the sky */
		for(i = 0; i < NUM_CLOUDS; i++)
		{
			random = rand();
			
			/* change direction occasionaly */
			if (random % 500 == 1)
				clouds_ary[i].direction *= -1;
			
			if (clouds_ary[i].direction > 0)
				(clouds_ary[i].x)++;
			else
				(clouds_ary[i].x) -=2;
					
			if (clouds_ary[i].x > GP142_XMAX + 45 || clouds_ary[i].x < -GP142_XMAX - 45)
				clouds_ary[i].x = -clouds_ary[i].x;
		}
		
        /* Redraw everything */
        DrawLandscape(sun_x, sun_y);
        DrawThermometer(thermo_y);
        DrawTree(trees_ary, &num_trees);
        
        for (i = 0; i < num_drops; i++)
        {
      	    DrawAllPrecipitation(drops_ary[i]);
    	}
    	
    	if(lightning_flg)
	    	DrawLightning(l_x1, l_y1, l_x2, l_y2, l_x3, l_y3, l_xf, l_yf);
    	
    	DrawClouds(clouds_ary);
    	DrawButtons(current_precip, current_color, draw_tree_flg, lightning_flg);
    	PrintText(&draw_tree_flg, &begin_flg);

      break;

    default:

      break;
	
    }  /*end switch */
		
  }  /* end event loop */
  
  /* WRAP-UP */
  GP142_close();         /* clean up and close graphics window   */

  return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/

/* This function is very important to the entire program. It adds the proper element
	to the array every time a mouse is clicked for precipitation. When the array
	fills up, we cycle back to the beginning of the array and replace older drops.
	*num_drops keeps track of how many drops are in the array at any given time.
	*drops_ary_counter tells us where in the array to add the next drop. These to
	variables are related, but not the same.*/

void AddDrop (int mouse_x, int mouse_y, int current_precip, int current_color, 
				drop_t drops_ary[], int *drops_ary_counter, int *num_drops)
{    
	if (*num_drops < MAX_PRECIP_EVENTS)
		(*num_drops)++;
	
	/* cycle back to beginning of array */ 
	if ( *drops_ary_counter > MAX_PRECIP_EVENTS - 1)
		*drops_ary_counter = 0;

	/* initialize a new drop array element */
	drops_ary[*drops_ary_counter].x = mouse_x;
	drops_ary[*drops_ary_counter].y = mouse_y;
	drops_ary[*drops_ary_counter].type = current_precip;
	drops_ary[*drops_ary_counter].color = current_color;
	
	/* initialize life expectancy of drops */
	switch (current_precip)
	{
		case RAIN:
			drops_ary[*drops_ary_counter].frame_count = RAIN_LIFE;
			break;
		case SNOW:
			drops_ary[*drops_ary_counter].frame_count = SNOW_LIFE;
			break;
		case HAIL:
			drops_ary[*drops_ary_counter].frame_count = HAIL_LIFE;
			break;
		default:
			break;
	}
	/* incremented every time this function is run to keep track of where
		to add the next element */	
	(*drops_ary_counter)++;
}

/* Steps through the array to check for drops to kill.
 Each time the while loop encounters a zero, it takes the next array
	element and moves it to the zero location. Hence the loop walks through
	the array only once */
void CheckAge(drop_t drops_ary[], int *num_drops, int *drops_ary_counter)
{
	int i, num_killed = 0;
	
    i = 0;
	while (i+num_killed < *num_drops)
	{
	    if (drops_ary[i+num_killed].frame_count == 0)
			num_killed++;
		else
		{
	      drops_ary[i] = drops_ary[i + num_killed];
		  i++;
		}   
	}
	/* if any drops expired, we reduce the number of total drops and adjust
		the array marker, *drops_ary_counter, accordingly */
	if (num_killed > 0)
	{
		*num_drops -= num_killed;
		*drops_ary_counter = *num_drops; 
	}
}

void Change_Temp (int mouse_y, drop_t drops_ary[], int *num_drops)
{
	int i, num_converted = 0;
	
	/* temperature is above freezing so everything melts into rain */
	if (mouse_y > 0)
	{
		for (i = 0; i < *num_drops && num_converted < 10; i++)
		{	
			if (drops_ary[i].type > 1)  /* is true for all snow and hail, but not none */
			{	drops_ary[i].type = RAIN;
				num_converted++;
			}
			if (drops_ary[i].frame_count > RAIN_LIFE)
				drops_ary[i].frame_count /= 2;
		}
	}
	
	/* temperature is below freezing so rain turns into snow */
	else
	{
		for (i = 0; i < *num_drops && num_converted < 10; i++)
		{	
			/* Don't change hail to snow, it's all ready frozen, 
			  but reduce the life of rain drops to the equivelent snow life*/
			if (drops_ary[i].type == RAIN)
			{	drops_ary[i].type = SNOW;
				drops_ary[i].frame_count /= 2;
				num_converted++;
			}
		}
	}
}
	/*reinitialize so that ALL current precipitation is erased.	*/
void  ClearAllPrecipitation(drop_t drops_ary[], int *num_drops)
{
	int i;

  for (i = 0; i < *num_drops; i++)
  {
  	drops_ary[i].type = NONE;
  }
}

#define RAINDROP_WIDTH 3
#define RAINDROP_HEIGHT 4

void DrawRainDrop (int x, int y, int color) 
{ 
	GP142_ovalXY(color,	x, y, x + RAINDROP_WIDTH, y + RAINDROP_HEIGHT, FILL);
}

#define SNOWDROP_WIDTH 4
#define SNOWDROP_HEIGHT 4

/* draws a six-pointed asterik for snow */
void DrawSnowDrop (int x, int y, int color) {

		/* top left to bottom right */
		GP142_lineXY(color, x, y + SNOWDROP_HEIGHT,	x + SNOWDROP_WIDTH, y, 1);

		/* top right to bottom left */
		GP142_lineXY(color, x+SNOWDROP_WIDTH, y+SNOWDROP_HEIGHT, x, y, 1);
		
		/* sraight accross */
		GP142_lineXY(color,	x, y + SNOWDROP_HEIGHT/2, 
			x+SNOWDROP_WIDTH, y +SNOWDROP_HEIGHT/2,	1);
}

/* draws square hail */
#define HAIL_WIDTH 4
#define HAIL_HEIGHT 4
void DrawHail (int x, int y, int color)
{
	GP142_rectangleXY(color, x, y, x + HAIL_WIDTH, y + HAIL_HEIGHT,	FILL);
}

void DrawAllPrecipitation(drop_t current_drop)
{
	if (current_drop.y >= TOP_OF_DIRT - 20) {
		switch (current_drop.type) {
		case RAIN:
			DrawRainDrop (current_drop.x, current_drop.y, current_drop.color);
			break;
		case SNOW:
			DrawSnowDrop (current_drop.x, current_drop.y, current_drop.color);
			break;
		case HAIL:
			DrawHail (current_drop.x, current_drop.y, current_drop.color);
			break;
		default:
			/*Bad news to ever get here.*/
			{}

		} /* end switch*/		
	}
}

/* Function is very similar to AddDrop, but it includes a sort */
void AddTree(int mouse_x, int mouse_y, tree trees_ary[], 
				int *trees_ary_counter, int *num_trees)
{   int i, sorted = 0; 
	tree temp;
	if (*num_trees < MAX_TREES)
		(*num_trees)++;
	
	/* cycle back to beginning of array */ 
	if ( *trees_ary_counter > MAX_TREES - 1)
		*trees_ary_counter = 0;
		
	trees_ary[*trees_ary_counter].x_left = mouse_x;
	trees_ary[*trees_ary_counter].y_bottom = mouse_y;
	trees_ary[*trees_ary_counter].age = 0;

	(*trees_ary_counter)++;
	
	/* sort array so the trees overlap correctly, draws with a smaller
		negative y coordinate should be drawn first so they come to the front
		of the array. Using bubble sort method, but since the array is so small
		it shouldn't be too slow. */
	i = 0;
	while (!sorted)
    {
      sorted = 1;
      while (i < *num_trees-1)
	  { 		
			if(trees_ary[i+1].y_bottom > trees_ary[i].y_bottom)
			{
				temp = trees_ary[i];
				trees_ary[i] = trees_ary[i+1];
				trees_ary[i+1] = temp;
				i = 0;
				sorted = 0;
			}
			else
			  i++;
	   }
	}
}

#define TREE_YEARS 10   /* conversion factor from frame count to tree time */

void DrawTree(tree trees_ary[], int *num_trees)
{
	int i, tree_age;
	

	for (i = 0; i < *num_trees; i++)
	{
		tree_age = trees_ary[i].age / TREE_YEARS;
		
		switch (tree_age)
		{
	
		case 0:
			GP142_rectangleXY(BLACK, trees_ary[i].x_left, trees_ary[i].y_bottom, 
				trees_ary[i].x_left +1, trees_ary[i].y_bottom + 5, FILL);
			GP142_ovalXY(FOREST_GREEN, trees_ary[i].x_left -1, trees_ary[i].y_bottom + 5, 
				trees_ary[i].x_left + 2, trees_ary[i].y_bottom + 8, FILL);
		  break;
		case 1:
			/*draw trunk */
			GP142_rectangleXY(BROWN, trees_ary[i].x_left, trees_ary[i].y_bottom,
				trees_ary[i].x_left + 2, trees_ary[i].y_bottom + 10, FILL);
			/* trunk outline */
			GP142_rectangleXY(BLACK, trees_ary[i].x_left, trees_ary[i].y_bottom,
				trees_ary[i].x_left + 2, trees_ary[i].y_bottom + 10, 1);
			/* leaf outline */
			GP142_circleXY(BLACK, trees_ary[i].x_left + 1, trees_ary[i].y_bottom + 10, 4);
			/* leaves */
			GP142_circleXY(FOREST_GREEN, trees_ary[i].x_left + 1, trees_ary[i].y_bottom + 10, 3);
		  break;
		case 2:
			/*draw trunk */
			GP142_rectangleXY(BROWN, trees_ary[i].x_left, trees_ary[i].y_bottom,
				trees_ary[i].x_left + 3, trees_ary[i].y_bottom + 15, FILL);
			/* trunk outline */
			GP142_rectangleXY(BLACK, trees_ary[i].x_left, trees_ary[i].y_bottom,
				trees_ary[i].x_left + 3, trees_ary[i].y_bottom + 15, 1);
			/* leaf outline */
			GP142_circleXY(BLACK, trees_ary[i].x_left + 1, trees_ary[i].y_bottom + 15, 5);
			/* leaves */
			GP142_circleXY(FOREST_GREEN, trees_ary[i].x_left + 1, trees_ary[i].y_bottom + 15, 4);
		  break;
		case 3:
			/*draw trunk */
			GP142_rectangleXY(BROWN, trees_ary[i].x_left, trees_ary[i].y_bottom,
				trees_ary[i].x_left + 4, trees_ary[i].y_bottom + 20, FILL);
			/* trunk outline */
			GP142_rectangleXY(BLACK, trees_ary[i].x_left, trees_ary[i].y_bottom,
				trees_ary[i].x_left + 4, trees_ary[i].y_bottom + 20, 1);
			/* leaf outline */
			GP142_circleXY(BLACK, trees_ary[i].x_left + 2, trees_ary[i].y_bottom + 20, 7);
			/* leaves */
			GP142_circleXY(FOREST_GREEN, trees_ary[i].x_left + 2, trees_ary[i].y_bottom + 20, 6);
		  break;
		case 4:
			/*draw trunk */
			GP142_rectangleXY(BROWN, trees_ary[i].x_left, trees_ary[i].y_bottom,
				trees_ary[i].x_left + 5, trees_ary[i].y_bottom + 25, FILL);
			/* trunk outline */
			GP142_rectangleXY(BLACK, trees_ary[i].x_left, trees_ary[i].y_bottom,
				trees_ary[i].x_left + 5, trees_ary[i].y_bottom + 25, 1);
			/* leaf outline */
			GP142_circleXY(BLACK, trees_ary[i].x_left + 3, trees_ary[i].y_bottom + 25, 9);
			/* leaves */
			GP142_circleXY(FOREST_GREEN, trees_ary[i].x_left + 3, trees_ary[i].y_bottom + 25, 8);
		  break;	
		case 5:
			/* Draw trunk */
			GP142_rectangleXY(BROWN, trees_ary[i].x_left, trees_ary[i].y_bottom,
				trees_ary[i].x_left+6, trees_ary[i].y_bottom+30,
				FILL);
			/* Draw black border */	
			GP142_rectangleXY(BLACK, trees_ary[i].x_left, trees_ary[i].y_bottom,
				trees_ary[i].x_left+6, trees_ary[i].y_bottom+30,
				1);
			/* Draw black border */		
			GP142_circleXY(BLACK,
				trees_ary[i].x_left+3, trees_ary[i].y_bottom+30,
				11);
			/* Draw leaves */
			GP142_circleXY(FOREST_GREEN, trees_ary[i].x_left+3, trees_ary[i].y_bottom+30, 10);
		  break;
		}
	}
}

void AddLightning(cloud clouds_ary[], int *l_x1, int *l_y1, int *l_x2, int *l_y2,
					int *l_x3, int *l_y3, int *l_xf, int *l_yf)
{
	int i, random, dist, dist_y;
	
	random = rand() % NUM_CLOUDS;
	
	/* get initial coordinate of lightning */
	for (i = 0; i < NUM_CLOUDS; i++)
	{
		if (clouds_ary[i].number == random)
		{
			*l_x1 = clouds_ary[i].x;
			*l_y1 = clouds_ary[i].y;
		}
		else 
		{
			*l_x1 = clouds_ary[1].x;
			*l_y1 = clouds_ary[1].y;
		}
		
		if (*l_x1 > GP142_XMAX)
			(*l_x1) -= 45;
			
		if (*l_x1 < -GP142_XMAX)
			(*l_x1) += 45;		
	}
	
	/* get final coordinate of lightning */
	*l_xf = rand() % 250;
	*l_yf =  -(rand() % (100- TOP_OF_DIRT));
	
	/* need to go negative on x half the time */
	random = rand() % 2;
	if (random)
		(*l_xf) *= -1;
	
	/* make lightning zig and zag. This is based on the separation of the initial
		and final coordinates. */
	dist = (*l_xf)-(*l_x1);
	
	if (dist < 0)
		dist *= -1;
	
	if (dist > 125)
	{	*l_x2 = (*l_x1) / 2;
		*l_x3 =  (*l_xf) / 2;
	}
	else 
	{	*l_x2 = ((*l_x1)*3) / 2;
		*l_x3 = ((*l_xf)*3)/ 2;
	}
	
	dist_y = (*l_yf)-(*l_y1);

	if (dist_y < 0)
		dist_y *= -1;
		
	if (dist_y > 100)
	{	*l_y2 = (*l_y1) / 2;
		*l_y3 =  (*l_yf) / 2;
	}
	else 
	{	*l_y2 = ((*l_x1)*3) / 2;
		*l_y3 = ((*l_xf)*3)/ 2;
	}	

}

void DrawLightning(int x1, int y1, int x2, int y2, int x3, int y3, int xf, int yf)
{
	GP142_lineXY(YELLOW, x1, y1, x2, y2, 3);
	GP142_lineXY(YELLOW, x2, y2, x3, y3, 3);
	GP142_lineXY(YELLOW, x3, y3, xf, yf, 3);
}

#define T_WIDTH 5

/* Draw the thermometer. Because we draw the thermometer acrosse the x-axis
	the y coordinate of the mercury height is the actual temperature in Celsisus*/
void DrawThermometer(int thermo_y)
{
	int ty;	
	/*draw white background */
  GP142_rectangleXY(WHITE, GP142_XMAX - T_WIDTH - 3, 40, 
  					GP142_XMAX - 3, -20, FILL);  
  GP142_circleXY(WHITE,	GP142_XMAX-5, 40, 2);	
  	/* mercury level */
  GP142_rectangleXY(RED, GP142_XMAX - T_WIDTH -3, thermo_y,
  					GP142_XMAX - 3, -20, FILL);	
  GP142_circleXY(RED, GP142_XMAX-5, -22, 4);
  	/* graduations on thermometer */
  GP142_printfXY(BLACK, GP142_XMAX - 24, 36, 8, " 40\n 30\n 20\n 10\n   0\n-10\n-20");
  
  for (ty = -20; ty <= 40; ty += 10)
  {	
  	GP142_lineXY(BLACK,	GP142_XMAX - 7, ty,	GP142_XMAX - 4 , ty, 1);
  }
}

void DrawClouds (cloud clouds_ary[])
{ int i;
  /* Draw the clouds */
  for (i = 0; i < NUM_CLOUDS; i++)
  {  
	GP142_circleXY(LT_GRAY, clouds_ary[i].x, clouds_ary[i].y, 20);
	GP142_circleXY(LT_GRAY, clouds_ary[i].x + 10, clouds_ary[i].y + 7, 15);
	GP142_circleXY(LT_GRAY, clouds_ary[i].x + 15, clouds_ary[i].y - 3, 11);
	GP142_circleXY(LT_GRAY, clouds_ary[i].x - 21, clouds_ary[i].y + 8, 19);
	GP142_circleXY(LT_GRAY, clouds_ary[i].x -31 , clouds_ary[i].y -2, 16);
  }
}


int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if ((mouse_x > GP142_XMAX - 9) && (mouse_y < 41) && (mouse_y > -21))
  	return THERMO; 
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;
}

/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *clear_weather, int *draw_tree_flg, int *lightning_flg, int *begin_flg)
{
  int buttonNum;

  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;		/*turn flags on and off throughout to update */
    *begin_flg = TRUE;			/* status bar */
    *draw_tree_flg = FALSE;
    break;
  case 1:
    *current_precip = SNOW;
    *begin_flg = TRUE;
    *draw_tree_flg = FALSE;
    break;
  case 2:
  	*current_precip = HAIL;
  	*begin_flg = TRUE;
  	*draw_tree_flg = FALSE;
  	break;
  case 3:
    *current_color = WHITE;
    *begin_flg = TRUE;
    *draw_tree_flg = FALSE;
    break;
  case 4:
    *current_color = BLUE;
    *begin_flg = TRUE;
    *draw_tree_flg = FALSE;
    break;
  case 5:
  	*current_color = LT_GRAY;
  	*begin_flg = TRUE;
  	*draw_tree_flg = FALSE;
  	break;
  case 6:					/*turn trees on and begin off */
  	*draw_tree_flg = TRUE;
  	*begin_flg = FALSE;
  	break;
  case 7:					/* turn lightning on and trees off */
  	*lightning_flg = TRUE;
  	*begin_flg = TRUE;
  	*draw_tree_flg = FALSE;
  	break;
  case 8:
    *clear_weather = TRUE;
    *begin_flg = TRUE;
    *draw_tree_flg = FALSE;
    break; /* Signal to clear up the weather */
  default:
		/*Bad news if this is ever reached! */
		GP142_printfXY (RED, 50, 50, 14, "BAAADD NEWS!");
    break;
  }
}

/* Draws the buttons */
void DrawButtons(int current_precip, int current_color, int draw_tree_flg, int lightning_flg)
{
  int i, text_offset = -GP142_XMAX + 10, font_size = 11;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  /* This whole mess could be cleaned and put into a function
  if we could use strings. */
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Rain");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Snow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Snow");
    
  i -= BUTTON_HEIGHT;
  if (current_precip == HAIL)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Hail");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Hail");
 
   /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(WHITE, text_offset, i, font_size, "White");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(BLUE, text_offset, i, font_size, "Blue");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Blue");
    
    i -= BUTTON_HEIGHT;
  if (current_color == LT_GRAY)
    GP142_printfXY(LT_GRAY, text_offset, i, font_size, "Light Gray");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Light Gray");

  /* Button for tree */
  i -= BUTTON_HEIGHT;
  if (draw_tree_flg == TRUE)
  	 GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Plant Tree");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Plant Tree");
    
    /* Button for lightning */
  i -= BUTTON_HEIGHT;
  if (lightning_flg == TRUE)
  	 GP142_printfXY(YELLOW, text_offset, i, font_size, "Lightning");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Lightning");

  /* This button is never "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Cease!");
}

void DrawLandscape(int sun_x, int sun_y)
{  
  /* Draw the sky first */
  GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
 
  /* Draw the sun */
  GP142_circleXY(YELLOW, sun_x, sun_y , 20);

  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
  GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT, FILL);

  /*Draw the mountains */
  GP142_triangleXY(MED_GRAY,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   0, (4 * GP142_YMAX)/5 ,
		   FILL);
   
	#if defined(MACINTOSH)

	    GP142_triangleXY(WHITE,
  			0, (4 * GP142_YMAX)/5,
  			GP142_XMAX/5, GP142_YMAX - 88,
  			-GP142_XMAX/5, GP142_YMAX - 88,
  			FILL);
    #else
	
		GP142_triangleXY(WHITE,
  			0, (4 * GP142_YMAX)/5,
  			GP142_XMAX/8 -1, GP142_YMAX - 85,
  			-GP142_XMAX/8, GP142_YMAX - 85,
  			FILL);
	#endif

  GP142_triangleXY(OLIVE,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);

} /*end DrawLandscape */

void PrintText (int *draw_tree_flg, int *begin_flg)
{
	int text_offset = -GP142_XMAX + 10, font_size = 11;
	
	if(*draw_tree_flg)
		GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click on the ground and watch your tree grow. :)");
	  
	if(*begin_flg)  
	{
	  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Select a weather type and a color, then click on the picture.");
	  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+15, font_size,
 		"Click on the thermometer to change the temperature.");
		}		
}
void BadNewsMessage (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}